local me = BrokerToolBox

local tool
tool = me:NewTool("equipment",{
	name={
		default="Equipment",
		deDE="Ausrüstung",
	},
	description={
		default="Equipment Manager\nUsed code from Broker_Equipment (thanks to p3lim)",
		deDE="Ausrüstungsmanager\nCode von Broker_Equipment verwendet (danke an p3lim)",
	},
	author="Sanori (/p3lim)",
	version="1.0",
	defaultON=true,
	ScanEquipment = function(self, name)		--Borrowed from p3lim's Broker_Equipment
		for slot, location in pairs(GetEquipmentSetLocations(name)) do
			local located = true
			if(location == 0) then
				located = not GetInventoryItemLink('player', slot)
			elseif(location ~= 1) then
				local player, bank, bags = EquipmentManager_UnpackLocation(location)
				located = player and not bank and not bags
			end
			if(not located) then
				return
			end
		end
		return true
	end,
	UpdateLDB = function(self)						--Borrowed from p3lim's Broker_Equipment
		for i = 1, GetNumEquipmentSets() do
			local name, icon = GetEquipmentSetInfo(i)
			if(self:ScanEquipment(name)) then
				self.broker.text = name
				self.broker.icon = icon
				return
			else
				self.broker.text = "???"
				self.broker.icon = "Interface\\Icons\\INV_Misc_QuestionMark"
			end
		end
	end,
	GetTextureIndex = function(self, texture)	-- Borrowed from tekkub's EquipSetUpdater
		RefreshEquipmentSetIconInfo()
		local numIcons = GetNumMacroIcons()
		for index = INVSLOT_FIRST_EQUIPPED, INVSLOT_LAST_EQUIPPED do
			if(GetInventoryItemTexture('player', index)) then
				numIcons = numIcons + 1
			end
		end
		for index = 1, numIcons do
			local icon, textureIndex = GetEquipmentSetIconInfo(index)
			if(icon == texture) then
				return textureIndex
			end
		end
	end,
	events={
		["UNIT_INVENTORY_CHANGED"] = function(self, unit)
			if unit == 'player' then
				self:UpdateLDB()
			end
		end,
		["EQUIPMENT_SETS_CHANGED"] = function(self) self:UpdateLDB() end,
	},
	broker = {											--Broker
		type = "data source",
		text = "???",
		icon = "Interface\\Icons\\INV_Misc_QuestionMark",
		OnClick = function(self, button)
			if InCombatLockdown() then return end
			if(button ~= 'RightButton' and GetNumEquipmentSets() > 0) then
				tool.menu:Open(self, 'children', function(level, value)
					for i = 1, GetNumEquipmentSets() do
						local name, icon = GetEquipmentSetInfo(i)
						if tool.broker.text==name then
							name = "|cff00ff00"..name.."|r"
						end
						tool.menu:AddFunc(name, function(self)
							if IsShiftKeyDown() then
								local dialog = StaticPopup_Show('CONFIRM_OVERWRITE_EQUIPMENT_SET', name)
								dialog.data = name
								dialog.selectedIcon = tool:GetTextureIndex(icon)
							elseif IsControlKeyDown() then
								local dialog = StaticPopup_Show('CONFIRM_DELETE_EQUIPMENT_SET', name)
								dialog.data = name
							else
								EquipmentManager_EquipSet(name)
							end
						end, icon, true)
					end
				end)
				return
			end
			ToggleCharacter('PaperDollFrame')
			GearManagerDialog:Show()
		end,
		OnTooltipShow = function(self)
			GameTooltip:AddLine(tool.name[GetLocale()] or tool.name.default)
			GameTooltip:AddLine(tool:L("Left-click"))
			GameTooltip:AddLine(tool:L("Right-click"))
			GameTooltip:AddLine(tool:L("Shift-click"))
			GameTooltip:AddLine(tool:L("Ctrl-click"))
		end,
	},
	PostInit = function(self)
		self:UpdateLDB()
	end,
})