--[[----------------------------------------------------------------------------
	sample file

	- database is aviable under tool.db
	- to get locales, use function tool:L("LOCALE")
	- database will be saved automatically (pls don't use event PLAYER_LOGOUT
	  for database changes)
	- dewdrop lib is aviable under me.dropdown (wrapper functions are in tool.menu, see last lines in core.lua for
	  wrapper functions)

	- please store all of the tool funcs and vars in the tool table (so that
	  your tool can be disabled completely without using memory)

	- don't forget to add your tool to BrokerToolBox\tools.xml
------------------------------------------------------------------------------]]
local me = BrokerToolBox							--required

--locale
me:NewL("sample",{									--default locale
	bsp = "Example",
})
me:NewL("sample",{									--deDE locale
	bsp = "Beispiel",
},"deDE")
--to get locale, use tool:L("LOCALE")

local tool
tool = me:NewTool("sample",{
	name={												--tool name (required)
		default="Sample",
		deDE="Beispiel",
	},
	description={										--tool description
		default="A sample tool",
		deDE="Ein Beispiel",
	},
	author="Sanori",									--author of this tool
	version="1.0",										--tool version
	defaultON=false,									--default active?
	db={													--tool database
		typ="sample",
	},
	OnUpdate = function(self, elapsed)			--OnUpdate Script
		return
	end,
	events={												--Game Events
		["UNIT_SPELLCAST_START"] = function(self, ...)	--sample
			print(...)
		end,
	},
	broker = {											--Broker
		type = "data source",
		text = "Sample",
		label = "?",
		icon = "",
	},
	PreInit = function(self)						--Event: PLAYER_LOGIN - called immediately before creating broker and before registering events and OnUpdate script (use this to init vars)
		self.myvar=0			--init a var
	end,
	PostInit = function(self)						--Event: PLAYER_LOGIN - called immediately after creating broker
		print(self.db.typ)	--print a save var
		self.broker.test = "<Sample>"
	end,
	PlayerLeavingWorld = function(self)			--Event: PLAYER_LEAVING_WORLD, called immediately before saving database, pls don't use event PLAYER_LOGOUT for database changes
		print(self:L("bsp"))	--print a locale
	end,
})